﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;
using WealthLab;
using System.Windows.Forms;
using System.IO;
using TASCIndicators;	//required
using System.Windows.Forms.DataVisualization.Charting;

namespace WealthLab.Strategies.Probability
{
    public class Probability : WealthScript
    {
        private StrategyParameter paramDummy;

        protected override void Execute()
        {
            var rrsi = RocketRSI.Series(Close, 8, 10);
            ChartPane paneRocketRSI = CreatePane(40, true, true);
            PlotSeries(paneRocketRSI, rrsi, Color.DarkBlue, LineStyle.Solid, 2);

            double[] bin = new double[61];
            for (int bar = GetTradingLoopStartBar(10 * 3); bar < Bars.Count; bar++)
            {
                for (int i = 1; i <= 60; i++)               //Bin the indicator values in Bins from -3 to +3
                {
                    double j = (i - 31) / 10d;
                    double k = (i - 30) / 10d;
                    if (rrsi[bar] > j && rrsi[bar] <= k)
                        bin[i] = bin[i] + 1;
                }
            }

            Chart chart = new Chart();                          //Histogram chart
            chart.Width = 600;
            string name = "Bins";
            chart.ChartAreas.Add(name);
            chart.ChartAreas[0].AxisX.MajorGrid.Enabled = chart.ChartAreas[0].AxisY.MajorGrid.Enabled = false;
            chart.ChartAreas[0].AxisX.Title = "Deviation";      //Custom axis titles
            chart.ChartAreas[0].AxisY.Title = "Occurences";
            chart.Series.Add(name);
            chart.Series[name].ChartType = SeriesChartType.Column;

            for (int b = 0; b < bin.GetLength(0); b++)
                chart.Series[name].Points.AddXY((b - 31) / 10d, bin[b]);

            using (MemoryStream memStream = new MemoryStream())
            {
                chart.SaveImage(memStream, ChartImageFormat.Png);
                Image img = Image.FromStream(memStream);
                DrawImage(PricePane, img, Bars.Count - 50, Close[Bars.Count - 50], false);
            }
        }
    }

    public class ProbabilityHelper : StrategyHelper
    {
        public override string Author => "Gene Geren";

        public override DateTime CreationDate => new DateTime(2019, 01, 27);

        public override string Description => "Probability";

        public override Guid ID => new Guid("15A0B80A-6C28-4726-A5F4-90D1C0809FCA");

        public override DateTime LastModifiedDate => new DateTime(2019, 01, 27);

        public override string Name => "Probability";

        public override Type WealthScriptType => typeof(Probability);
    }
}
